'use strict';

exports.__esModule = true;

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _rxjs = require('rxjs');

var _rxjs2 = _interopRequireDefault(_rxjs);

var _isObservable = require('is-observable');

var _isObservable2 = _interopRequireDefault(_isObservable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var flatten = function flatten(list) {
  return list.reduce(function (a, b) {
    return a.concat(Array.isArray(b) ? flatten(b) : b);
  }, []);
};

/**
 * combine multiple reducers (observable streams of functions)
 * into one stream that is pushed to `createState`.
 *
 * It is the stream of functions that take one argument (state)
 * and generate newState with this function.
 *
 * @param  {Observables} reducers one or many reducers streams (Observables).
 * @return {Observable} Observable that produces functions how to
 * modify state.
 */
var combineReducers = function combineReducers() {
  var _Rx$Observable;

  for (var _len = arguments.length, reducers = Array(_len), _key = 0; _key < _len; _key++) {
    reducers[_key] = arguments[_key];
  }

  var flatened = flatten(reducers);
  var reducersArr = [].concat(flatened).filter(function (item) {
    return (0, _isObservable2['default'])(item);
  });
  // console.log('RA: ', reducersArr);
  return (_Rx$Observable = _rxjs2['default'].Observable).merge.apply(_Rx$Observable, (0, _toConsumableArray3['default'])(reducersArr));
};

exports['default'] = combineReducers;